Note: This is a beta version of Broker_Keystones.  Though it has been tested in the alpha channel, you may still encounter some issues.  Please consider sending bug reports if you do.  Thank you.

8.0.1-12.b3
* The issue that was "fixed" in the last release is not actually fixed.  After some investigation it seems to be an issue on Blizzard's side.  Reports have been sent but for now, all I can do is implement a bit of a dodgy workaround for it.
* When you complete a Mythic+ dungeon, the addon should be able to record the information accurately.  Any time after that, the C_MythicPlus functions may actually return information about a character you were logged in to previously and not your current character.
* A fallback has been implemented.  If the addon needs to read your best run information outside of a run, it will be able to record your level, but not the dungeon that you ran.  When possible, it will preserve that information when it can.

8.0.1-12.b2
* Fix: Characters' best runs were not being recorded.

8.0.1-12.b1
* NOTE: You will need to restart your WoW game client after installing this version due to file changes that a /reloadui will not pick up.
* Support for Battle for Azeroth (backwards-compatible with Legion.)
* New: Tooltip has been revamped; it now shows keystones and records in a columnar view and realms/characters are sorted properly.  The classic tooltip can be re-enabled in Options, but will no longer receive feature updates.
* New: Added minimap button for users who choose not to use a data broker display addon.
* New: Shorthand names for known Battle for Azeroth dungeons.
* New: Keystone levels can now be coloured according to difficulty (2+ white, 4+ green, 7+ blue, 10+ purple, 15+ orange, 18+ light gold.)  Enabled by default.
* New: Best run can now be displayed in the broker text in addition to current keystone.
* New: There is a new option to automatically insert keystones into the Keystone Font at the start of a dungeon.
* New: The addon now detects when a character who had a keystone no longer has it as a result of the weekly reset (it can also happen if the keystone is deleted manually, though.)  When this happens, the player will be prompted to purge keystone and best run information from their other characters too.
* New: There is a new option that makes the above function an automatic action (it runs without the prompt.)
* Fix: Best run scanning now uses new methods and events introduced in the Battle for Azeroth pre-patch.
* Fix: Keystones sometimes failed to be detected in situations where item information was unavailable during scans due to lag.
* Fix: Character information will always be updated at login, which solves an issue where (for example) a character creates a monk named Tom, then deletes the monk and creates a warlock named Tom.  In this case, the addon used to report that Tom was still a monk instead of updating that information.
* Fix: Remove leftover references to keystone depletion.  I don't think that mechanic is coming back.
* Fix: (#10) Characters' keystone and record info was being wiped out on every login, causing a conflict with the new weekly reset detection feature.
* Methods for deleting keystone and best run information have been updated.
* Updated LibUIDropDownMenu for Battle for Azeroth, added new dependencies on LibQTip (columnar tooltip) and LibDBIcon (minimap button.)
* Best run dungeon names are now displayed with white text (formerly grey) in the new tooltip.
* Characters on other factions will now show their faction icons next to their names in the new tooltip.
* Some shorthand dungeon names have been changed (EoA -> Eye, CoS -> Court, etc.) for better readability.
* When keystone and best run data is purged, the current best run information will be shifted to a new "previous best runs" area and marked as such in the new tooltip.  Previous Best Runs data will be deleted on a per-character basis when they either loot their mythic cache and get a keystone or gain a new best run that week (i.e. run any mythic+ dungeon.)

7.3.0-11.1
* Backport a fix for keystones failing to be detected in situations where item information was unavailable during scans due to lag.

7.3.0-11
* Add English shorthand name for Seat of the Triumvirate keystones (SotT).
* Shorten the Karazhan names further (Lower Kara -> L.Kara, Upper Kara -> U.Kara).
* In case a report is too long to fit into a single WoW chat message, split it up and send individual chat messages.  This can look a little messy; it's a quick workaround if nothing else.

7.3.0-10
* Support for 7.3.
* Use "NoTaint UIDropDownMenu" lib.

7.2.5-9.1
* Support for 7.2.5.

7.2.0-9
* Allow players to de-anonymise their reports (changes "Hunter" into the character's actual name).
* Allow player to include other-realm and other-faction characters in keystone/record reports.
* Add options to toggle the above behaviours.
* Clean up the context menus.
* Colour-code the guild/group report options using the channel colours that the user has set (default: green for guild, blue for group).
* Use a custom GetRealmName() function that strips spaces from realms for consistent return values with GetAutoCompleteRealms().

7.2.0-8.2
* Move responsibility of handling mouseover events to the broker display addon.

7.2.0-8.1
* Add some checks in cases where characters may not be retrieved.
* Use consistent functions to retrieve the player's realm name.
* Fix issue where broker text did not update when toggling shorthand dungeon names.
* Fix issue with context menu having inconsistent checkbox states.

7.2.0-8
* The broker now collects information about the highest level dungeons your characters have completed and displays it alongside their keystone. The tooltip display can be disabled in options.
* Clicking the broker will now bring up a list of various reporting options, allowing you to send a list of your keystones or records on the current realm/faction to your guild, group, or chat box.
* Fixed a race condition that may occur when the bag scan finishes before the addon itself is fully initialised.
* Improved options handling for future usage.

7.2.0-7
* Shift-clicking the broker will insert a link to the current keystone (if any) into the current chat window.
* Old keystone data should now be deleted when the weekly reset occurs.
* Experimental support for shorthand dungeon names (e.g. "Maw of Souls" becomes "Maw", "Court of Stars" becomes "CoS", etc.)  English locales only, for the moment.
* Add a context menu to the broker with two entries: 1) allow the user to toggle shorthand mode, 2) allow the user to manually clear keystone data.

7.2.0-6
* Switch to a callback system for events.

7.2.0-5
* Improve tooltip display.
* Stagger bag scanning a bit more (now 5 seconds after the bag update event, up from 1 second).
* Improve bag scanning by checking for the keystone item ID instead of trying to match the link string.
* Add some debug prints.

7.2.0-4
* Broker now displays the current character's keystone in its text for at-a-glance checking.
* Basically rewrote the internals to make the code ready for several planned features.
* Use own bag scanning instead of relying on DataStore (and remove it as a dependency).
* Preliminary support for display keystones that don't belong to the player (e.g. guild). Not yet implemented, however.
* Preliminary support for gathering information on highest dungeons completed (same).

7.2.0-1
* Initial release for 7.2.
* ToC update.
* Fix: Keystone link format was changed in the patch. This update allows the addon to read it again.
* Fix: keystone wasn't being updated in DataStore whenever its status changed (e.g. becoming depleted after putting it in, becoming un-depleted and having its level/instance changed when successfully completing the dungeon). Implemented a workaround until that can be properly fixed.
* Known issue: keystones from previous week will still show up until you log into that character to clear it. (Won't affect this week due to new keystone link format though.)

1.0-beta3
* Fix ToC file

1.0-beta2
* Fixed issue with reading depletion status of lower keystones.

1.0-beta1
* This is the first release of the addon.
