local _, addon = ...

-- functions
local select = select
local C_ChallengeMode = C_ChallengeMode
local C_ChallengeMode_SlotKeystone = C_ChallengeMode.SlotKeystone
local CreateFrame = CreateFrame
local CursorHasItem = CursorHasItem
local IsAddOnLoaded = IsAddOnLoaded
local GetContainerItemID = GetContainerItemID
local GetContainerNumSlots = GetContainerNumSlots
local PickupContainerItem = PickupContainerItem
-- constants
local NUM_BAG_SLOTS = NUM_BAG_SLOTS
-- frames
-- libs

local KEYSTONE_ITEM_ID = 138019

local function slotKeystone()
    if not addon.options.autoSlotKeystones then return end

    for bagId = 0, NUM_BAG_SLOTS do
        for slotId = 0, GetContainerNumSlots(bagId, slotId) do
            local itemId = GetContainerItemID(bagId, slotId)
            if KEYSTONE_ITEM_ID == itemId then
                PickupContainerItem(bagId, slotId)
                if CursorHasItem() then
                    C_ChallengeMode_SlotKeystone()
                end
            end
        end
    end
end

local hooked = false
local function hook()
    if not hooked then
        ChallengesKeystoneFrame:HookScript("OnShow", slotKeystone)
        hooked = true
    end
end

local function slotFrameOnEvent(self, event, ...)
    if event == "ADDON_LOADED" then
        local loadedAddonName = select(1, ...)
        if loadedAddonName == "Blizzard_ChallengesUI" then
            hook()
        end
    end
end

local slotFrame = CreateFrame("frame")
slotFrame:SetScript("OnEvent", slotFrameOnEvent)
if IsAddOnLoaded("Blizzard_ChallengesUI") then
    hook()
else
    slotFrame:RegisterEvent("ADDON_LOADED")
end
