local addonName, addon = ...

-- functions
local CreateFrame = CreateFrame
-- constants
-- frames
local UIParent = UIParent
-- libs
local L_EasyMenu = L_EasyMenu

local contextMenu = {
    menuFrame = CreateFrame("frame", "BrokerKeystonesContextMenuFrame", UIParent, "UIDropDownMenuTemplate"),
    item = {
        Action = function(self, label, func)
            return {text = label, notCheckable = true, func = func}
        end,
        Checkbox = function(self, label, checked, func)
            return {text = label, keepShownOnClick = true, isNotRadio = true, checked = checked, func = func}
        end,
        Separator = function(self)
            return {text = " ", disabled = true, notCheckable = true}
        end,
        SubMenu = function(self, title, menuList)
            return {text = title, notCheckable = true, hasArrow = true, menuList = menuList}
        end,
        Title = function(self, title)
            return {text = title, isTitle = true, notCheckable = true}
        end,
        OptionToggle = function(self, label, key)
            return self:Checkbox(
                label,
                function() return addon.options[key] end,
                function() addon.options[key] = not addon.options[key] end
            )
        end,
    },
}

function contextMenu:Show(menu)
    L_EasyMenu(menu, self.menuFrame, "cursor", 0, 0, "MENU")
end

addon:RegisterCallback(addon.EVENT_BROKER_INITIALISED, function(_, broker)
    broker.contextMenu = contextMenu
end)
